P=gcc
V=6.4.0
MAJOR=64
MINOR=0

S="
gcc-$V.tar.xz http://ftp.gnu.org/gnu/gcc/gcc-$V/gcc-$V.tar.xz
gmp-6.0.0a.tar.xz http://ftp.gnu.org/gnu/gmp/gmp-6.0.0a.tar.xz
mpfr-3.1.5.tar.xz http://ftp.gnu.org/gnu/mpfr/mpfr-3.1.5.tar.xz
mpc-1.0.3.tar.gz http://ftp.gnu.org/gnu/mpc/mpc-1.0.3.tar.gz
gmp-6.0.0-no-asm.patch
"

SHA512="
02c60e54527c7adf584798d5251f8a0b80c93d5deafce82501b2c28e6692e0bd783927bbfc4bc527a863c0cccc025150a34740a9e29badb02d4b48e56a8aba90  gcc-6.4.0.tar.xz
50368f4368b244b442438ce1768cf0f1166e490d1bafb8feda1ffc90fea3807e7328f30f3faa861799e4f5ff6e3113049ca3231b2f48571e4583fc3d60441816  gmp-6.0.0a.tar.xz
3643469b9099b31e41d6ec9158196cd1c30894030c8864ee5b1b1e91b488bccbf7c263c951b03fe9f4ae6f9d29279e157a7dfed0885467d875f107a3d964f032  mpfr-3.1.5.tar.xz
0028b76df130720c1fad7de937a0d041224806ce5ef76589f19c7b49d956071a683e2f20d154c192a231e69756b19e48208f2889b0c13950ceb7b3cfaf059a43  mpc-1.0.3.tar.gz
"

_target () {
	gcc -v 2>&1 | sed -n '/^Target:/ s/.* //p'
}

build () {
	top=$PWD
	tgt=`_target`

	tar xf gmp-6.0.0a.tar.xz
	tar xf mpfr-3.1.5.tar.xz
	tar xf mpc-1.0.3.tar.gz
	tar xf gcc-$V.tar.xz
	mkdir build

	cd gmp-6.0.0
	patch -p1 <../gmp-6.0.0-no-asm.patch

	# In-tree dependency builds
	cd ../gcc-$V
	mv ../gmp-6.0.0 gmp
	mv ../mpfr-3.1.5 mpfr
	mv ../mpc-1.0.3 mpc

	# Kill fixincludes
	cd gcc
	sed -e '/^STMP_FIXINC/ s/=.*/=/' \
	    -e '/^LIMITS_H_TEST/ s/=.*/= false/' \
		Makefile.in >Makefile.in.new
	mv Makefile.in.new Makefile.in
	#mkdir -p ../../build/gcc/include-fixed
	#cat limitx.h glimits.h limity.h >../../build/gcc/include-fixed/limits.h
	# ^ otherwise it only uses glimits.h which doesn't include the system's limits.h and isn't enough for some libs
	# ^ doesn't work (overwritten by the build)
	cd ..

	cd ../build
	# libsanitizer: unportable googletronics, doesn't build on musl
	# libmpx: Intel Memory Protection Extensions, needs PATH_MAX from the system limits.h
	../gcc-$V/configure \
		--build=$tgt \
		--host=$tgt \
		--target=$tgt \
		--prefix=/gales/pkg/$Q \
		--with-local-prefix=/local \
		--with-native-system-header-dir=/include \
		--disable-bootstrap \
		--disable-libmpx \
		--disable-libsanitizer \
		--disable-libstdcxx-pch \
		--disable-lto \
		--disable-multilib \
		--disable-nls \
		--disable-shared \
		--enable-threads=posix \
		--enable-__cxa_atexit \
		--enable-languages=c,c++
	make -j$JOBS
	make install-strip DESTDIR=$top/root

	cd $top/root/gales/pkg/$Q
	# Avoid hard links, libtool junk, and internal static libs
	rm -f lib*/libiberty.a lib*/*.la bin/$tgt-* bin/c++
	ln -s g++ bin/c++
}

package () {
	cd root/gales/pkg
	a gales/pkg/$Q
	i "Use the /gales/pkg/gcc symlink to set the default compiler version."
}
