/* Minimal necessities extracted or stubbed from the big ugly filename.c */

#include "less.h"
#include <sys/stat.h>

/* Try to determine the size of a file by seeking to the end. */
static off_t seek_filesize(int f)
{
	off_t spos = lseek(f, (off_t)0, SEEK_END);
	if (spos == BAD_LSEEK)
		return NULL_POSITION;
	return spos;
}

/* Return the size of a file, as cheaply as possible.
 * In Unix, we can stat the file. */
off_t filesize(int f)
{
	struct stat statbuf;
	if (fstat(f, &statbuf) >= 0)
		return statbuf.st_size;
	return seek_filesize(f);
}

/* LESSOPEN/LESSPIPE disabled */
char *open_altfile(char *filename, int *pf, void **pfd)
{
	return NULL;
}

void close_altfile(char *altfilename, char *filename, void *pipefd)
{
}

/* These functions didn't exactly do shell quoting, and are still used
 * internally even without HAVE_SHELL or HAVE_POPEN. It's hard to say what they
 * actually did, but probably not what you'd expect half the time. */
char *shell_unquote(char *s)
{
	return save(s);
}

char *shell_quote(char *s)
{
	return save(s);
}

/* Return last component of a pathname. */
char *last_component(char *name)
{
	char *slash;
	for (slash = name + strlen(name);  slash > name; )
	{
		--slash;
		if (*slash == *PATHNAME_SEP || *slash == '/')
			return slash + 1;
	}
	return name;
}
