P=nginx
V=1.12.2
MAJOR=0
MINOR=0

# QA: review README.gales

# Mirrored from nginx.org, removed scripts & banner ads, fixed up links
docs=nginx-docs-en-20180228

S="
$P-$V.tar.gz http://nginx.org/download/$P-$V.tar.gz
$docs.tar.gz
README.gales
run
"

SHA512="
3faa2043e237a7e1d15cc5661ac9d002a965220a78c25a863be9f19e01007347e53f776b61c229f6bd3d916cc1ccf92de260811f7b8092ec1b747fba7c0061f7  nginx-1.12.2.tar.gz
df61f2562940d7a4708ca53be35fc2d6ab0879816a71f88c0a69ed4dd1f0033ffbd3f6622a582293d810027e9fdde3bbde4d646703ca20f90088c8a0298dc30b  nginx-docs-en-20180228.tar.gz
"

build () {
	tar xzf $docs.tar.gz
	rm $docs/cleanup.sh

	tar xzf $P-$V.tar.gz
	cd $P-$V
	# There's a -Wsign-compare in the expansion of CMSG_NXTHDR
	# http://www.openwall.com/lists/musl/2018/03/06/4
	(cd auto/cc
	    grep -v '^CFLAGS="\$CFLAGS -Werror"$' gcc >tmp; mv tmp gcc)
	./configure --prefix=/var/lib/nginx \
		--conf-path=/etc/nginx/nginx.conf \
		--user=nginx \
		--group=nginx \
		--without-http_gzip_module \
		--without-http_rewrite_module
	make -j$JOBS
}

package () {
	a gales/pkg/$Q/doc/html $docs
	f gales/pkg/$Q/doc/README.gales
	(cd $P-$V
	    f gales/pkg/$Q/doc/CHANGES
	    f gales/pkg/$Q/doc/LICENSE
	    (cd objs
	        X gales/pkg/$Q/bin/nginx
	        f gales/pkg/$Q/man/man8/nginx.8)
	    a etc/examples/nginx conf)
	x etc/examples/svc/nginx/run
	l etc/examples/svc/nginx/log/run /etc/svc.defs/multilog
	d var/lib/nginx/logs
	l gales/pkg/$P $Q
	l gales/command/nginx ../pkg/$P/bin/nginx
	l gales/doc/$P ../pkg/$P/doc
	l gales/man/$P ../pkg/$P/man
	i 'See /gales/doc/nginx/README.gales to get started.'
}
