P=readline
V=7.0
MAJOR=0
MINOR=1

# Build requires: autoconf
# Supposedly requires: ncurses

# The upstream patches (http://ftp.gnu.org/gnu/readline/readline-7.0-patches/readline70-001 etc.) have been converted to unified diff format as BusyBox patch doesn't handle anything else.

S="
$P-$V.tar.gz http://ftp.gnu.org/gnu/$P/$P-$V.tar.gz
readline70-001.patch
readline70-002.patch
readline70-003.patch
"

SHA512="
18243189d39bf0d4c8a76cddcce75243c1bae8824c686e9b6ba352667607e5b10c5feb79372a1093c1c388d821841670702e940df12eae94bcebdeed90047870  readline-7.0.tar.gz
"

build () {
	root=$PWD/root
	tar xzf $P-$V.tar.gz
	cd $P-$V
	patch -p1 <../readline70-001.patch
	patch -p1 <../readline70-002.patch
	patch -p1 <../readline70-003.patch
	autoconf
	# XXX uses massive aclocal.m4 from bash, copied programs in support/ and doc/
	./configure \
		--prefix=/gales/pkg/$Q \
		--datarootdir=/gales/pkg/$Q \
		--docdir=/gales/pkg/$Q/doc \
		--disable-shared
	make -j$JOBS
	make install DESTDIR=$root
	cd $root/gales/pkg/$Q
	mv readline examples
}

package () {
	cd root/gales/pkg
	a gales/pkg/$Q
	l gales/pkg/$P $Q
	l gales/doc/$P ../pkg/$P/doc
	l gales/man/$P ../pkg/$P/man
	l gales/info/history.info ../pkg/$P/info/history.info
	l gales/info/readline.info ../pkg/$P/info/readline.info
	l gales/info/rluserman.info ../pkg/$P/info/rluserman.info
}
