P=sbcl
V=1.3.16
MAJOR=10
MINOR=0

# Build requires: clisp

S="
$P-$V-source.tar.bz2
sbcl-1.3.16-musl-fixes.patch
sbcl-1.3.16-deterministic-bin.patch
sbcl-1.3.16-no-unicode-src.patch
"

SHA512="
6bb0a7c926ba8031c319697b49b85eb58ea262d47237b2e7735738ad6103a759016a269e617931095174066f830e2edc362bf89384a97c3d19807552caf826b4  sbcl-1.3.16-source.tar.bz2
"

build () {
	root=$PWD/root
	tar xjf $P-$V-source.tar.bz2
	cd $P-$V
	patch -p1 <../sbcl-1.3.16-musl-fixes.patch
	patch -p1 <../sbcl-1.3.16-deterministic-bin.patch
	patch -p1 <../sbcl-1.3.16-no-unicode-src.patch
	# unicode-in-source crapolade
	rm tests/data/compile-file-pos.lisp tests/enc-*
	# FFI mechanism (sb-alien) assumes dynamic linking
	(cd contrib; rm -r sb-bsd-sockets sb-gmp sb-mpfr sb-posix sb-simple-streams)
	sh make.sh \
		--prefix=/gales/pkg/$Q \
		--without-sb-unicode \
		--xc-host='clisp -q -norc -on-error exit'
	INSTALL_ROOT=$root \
		MAN_DIR=$root/man \
		INFO_DIR=$root/info \
		DOC_DIR=$root/doc \
		sh install.sh
	#make -C doc/manual info [resulting info file is half-broken...]
}

check () {
	echo 'Test suite broken without SB-POSIX; skipping'
	return
	cd $P-$V/tests
	sh run-tests.sh
}

package () {
	cd root
	X gales/pkg/$Q/bin/sbcl bin/sbcl
	for f in BUGS COPYING CREDITS NEWS; do
		f gales/pkg/$Q/doc/$f doc/$f
	done
	f gales/pkg/$Q/man/man1/sbcl.1 man/man1/sbcl.1
	cd lib/sbcl
	a gales/pkg/$Q/lib/sbcl/contrib
	F gales/pkg/$Q/lib/sbcl/sbcl.core
	f gales/pkg/$Q/lib/sbcl/sbcl.mk

	l gales/pkg/$P $Q
	l gales/command/sbcl ../pkg/$P/bin/sbcl
	l bin/sbcl ../gales/pkg/$P/bin/sbcl #! portability
	l gales/doc/$P ../pkg/$P/doc
	l gales/man/$P ../pkg/$P/man
	d gales/common-lisp/source
	d gales/common-lisp/systems
	# ASDF looks for common-lisp in:
	# - the XDG_DATA_DIRS environment variable, if set
	# - otherwise: /usr/local/share, /usr/share
	l share/common-lisp ../gales/common-lisp
}
